#include <p24FJ64GA002.h>
#include <stdio.h>
#include "i2c.h"

#include "delay.h"
#include "bc_ami602.h"

//
//**************************************************************
//**************************************************************
//
void ami602_reset() {

	// AMI602 Zbg Suspend modeɂ܂
	AMI602_TRG = 1;		// o̓s̏
	AMI602_RESET = 1;
	delay_us(100);		// Ô߂Ɉ҂

	AMI602_RESET = 0;
	delay_us(10);			// RESET ێ
	AMI602_RESET = 1;
	delay_ms(50);			// Zbgs҂

	while(!AMI602_BUSY);	// BUSYtO 1ł邱ƂmF

	return;				// Zbg

}

void ami602_active() {

	// Suspend mode active mode ֑Jڂ܂
	// Power down modeɂȂĂꍇ Suspend mode֑Jڂ܂

	AMI602_TRG = 0;
	delay_us(20);				// TRG 20usێ
	AMI602_TRG = 1;
	delay_ms(40);				// 40msec ҂

	while(!AMI602_BUSY);		// BUSYtO 1ł邱ƂmF

	return;						// active mode (or suspend mode)

}


void ami602_READ_CMD(
	unsigned char cmd,
	unsigned int length,
	unsigned char *buffer,
	unsigned int wait1,
	unsigned int wait2,
	unsigned int wait3 ) {

	unsigned char command[1];

	delay_us(wait1);

	*command = cmd;
	i2c_start();
	i2c_send(AMI602_ADDRESS, 1, command);
	i2c_stop();

	delay_us(wait2);

	i2c_start();
	i2c_recv(AMI602_ADDRESS, length, buffer);
	i2c_stop();

	delay_us(wait3);

	return;

}

unsigned char ami602_WRITE_CMD(
	unsigned int length,
	unsigned char *buffer,
	unsigned int wait1,
	unsigned int wait2,
	unsigned int wait3  ) {

	unsigned char result[1];

	delay_us(wait1);
	i2c_start();
	i2c_send(AMI602_ADDRESS, length, buffer);
	i2c_stop();
	delay_us(wait2);

	i2c_start();
	i2c_recv(AMI602_ADDRESS, 1, result);
	i2c_stop();
	delay_us(wait3);

	return( *result );

}
