//
//
#ifndef __BC_AMI602_H_
#define __BC_AMI602_H_


//  AMI602
#define AMI602_ADDRESS					0x30
#define AMI602_RESET					LATBbits.LATB9
#define AMI602_BUSY						PORTBbits.RB8
#define AMI602_TRG						LATBbits.LATB7

//
// AMI602 R}h`
//     [hR}h
//			#define  <R}h>			<R}hԍ>
//			#define  <R}h>_size		Mf[^TCY + 1
//			#define  <R}h>_wait1		cmd1 Ȏ҂
//			#define  <R}h>_wait2		cmd1cmd2̊Ԃ̑҂
//			#define  <R}h>_wait3		cmd2 ̑҂
//
//     CgR}h
//			#define  <R}h>			<R}hԍ>
//			#define  <R}h>_size		Mf[^TCY
//			#define  <R}h>_wait1		cmd1 Ȏ҂
//			#define  <R}h>_wait2		cmd1cmd2̊Ԃ̑҂
//			#define  <R}h>_wait3		cmd2 ̑҂
//
// **************************************************************
//
//	AMI602 [hR}h
#define GET_COSR						0x11
#define GET_COSR_size					8
#define GET_COSR_wait1					20
#define GET_COSR_wait2					200
#define GET_COSR_wait3					30

#define GET_FINR						0x12
#define GET_FINR_size					8
#define GET_FINR_wait1					20
#define GET_FINR_wait2					200
#define GET_FINR_wait3					30

#define GET_MES_SUSPEND					0x28
#define GET_MES_SUSPEND_size			11
#define GET_MES_SUSPEND_wait1			20
#define GET_MES_SUSPEND_wait2			200
#define GET_MES_SUSPEND_wait3			30

#define GET_MES							0x14
#define GET_MES_size					11
#define GET_MES_wait1					20
#define GET_MES_wait2					200
#define GET_MES_wait3					30

#define GET_DAT							0x21
#define GET_DAT_size					8
#define GET_DAT_wait1					20
#define GET_DAT_wait2					200
#define GET_DAT_wait3					30

#define GET_FIRMWARE					0x17
#define GET_FIRMWARE_size				9
#define GET_FIRMWARE_wait1				20
#define GET_FIRMWARE_wait2				200
#define GET_FIRMWARE_wait3				30

#define GET_MES_PED_AUTO_SUSPEND		0x32
#define GET_MES_PED_AUTO_SUSPEND_size	11
#define GET_MES_PED_AUTO_SUSPEND_wait1	20
#define GET_MES_PED_AUTO_SUSPEND_wait2	200
#define GET_MES_PED_AUTO_SUSPEND_wait3	30

#define GET_MES_AVG						0x33
#define GET_MES_AVG_size				3
#define GET_MES_AVG_wait1				20
#define GET_MES_AVG_wait2				200
#define GET_MES_AVG_wait3				30

#define GET_GAIN						0x10
#define GET_GAIN_size					8
#define GET_GAIN_wait1					20
#define GET_GAIN_wait2					200
#define GET_GAIN_wait3					30

#define GET_PED_TH						0x36
#define GET_PED_TH_size					19
#define GET_PED_TH_wait1				20
#define GET_PED_TH_wait2				550
#define GET_PED_TH_wait3				30

#define GET_MES_T						0x15
#define GET_MES_T_size					4
#define GET_MES_T_wait1					20
#define GET_MES_T_wait2					450
#define GET_MES_T_wait3					30

//  AMI602 CgR}h
#define REQ_MES							0x55
#define REQ_MES_size					0
#define REQ_MES_wait1					20
#define REQ_MES_wait2					350
#define REQ_MES_wait3					0

#define SET_PWR_DOWN					0x57
#define SET_PWR_DOWN_size				2
#define SET_PWR_DOWN_wait1				20
#define SET_PWR_DOWN_wait2				350
#define SET_PWR_DOWN_wait3				30

#define SET_SUSPEND						0x75
#define SET_SUSPEND_size				2
#define SET_SUSPEND_wait1				20
#define SET_SUSPEND_wait2				350
#define SET_SUSPEND_wait3				30

#define SET_COSR						0x5b
#define SET_COSR_size					6
#define SET_COSR_wait1					20
#define SET_COSR_wait2					350
#define SET_COSR_wait3					30

#define SET_FINR						0x5c
#define SET_FINR_size					6
#define SET_FINR_wait1					20
#define SET_FINR_wait2					350
#define SET_FINR_wait3					30

#define SET_INDEX_DAT					0x63
#define SET_INDEX_DAT_size				1
#define SET_INDEX_DAT_wait1				20
#define SET_INDEX_DAT_wait2				350
#define SET_INDEX_DAT_wait3				30

#define SET_AEN							0x74
#define SET_AEN_size					1
#define SET_AEN_wait1					20
#define SET_AEN_wait2					350
#define SET_AEN_wait3					30

#define SET_MES_6CH_AUTO_START			0x64
#define SET_MES_6CH_AUTO_START_size		3
#define SET_MES_6CH_AUTO_START_wait1	20
#define SET_MES_6CH_AUTO_START_wait2	350
#define SET_MES_6CH_AUTO_START_wait3	450

#define SET_MES_6CH_AUTO_STOP			0x65
#define SET_MES_6CH_AUTO_STOP_size		2
#define SET_MES_6CH_AUTO_STOP_wait1		20
#define SET_MES_6CH_AUTO_STOP_wait2		350
#define SET_MES_6CH_AUTO_STOP_wait3		450

#define SET_MES_PED_AUTO_START			0x77
#define SET_MES_PED_AUTO_START_size		2
#define SET_MES_PED_AUTO_START_wait1	20
#define SET_MES_PED_AUTO_START_wait2	350
#define SET_MES_PED_AUTO_START_wait3	450

#define SET_MES_PED_AUTO_STOP			0x78
#define SET_MES_PED_AUTO_STOP_size		2
#define SET_MES_PED_AUTO_STOP_wait1		20
#define SET_MES_PED_AUTO_STOP_wait2		350
#define SET_MES_PED_AUTO_STOP_wait3		450

#define CLR_PED_SUSPEND					0x79
#define CLR_PED_SUSPEND_size			0
#define CLR_PED_SUSPEND_wait1			20
#define CLR_PED_SUSPEND_wait2			350
#define CLR_PED_SUSPEND_wait3			30

#define CHG_MES_AVG						0x80
#define CHG_MES_AVG_size				1
#define CHG_MES_AVG_wait1				20
#define CHG_MES_AVG_wait2				350
#define CHG_MES_AVG_wait3				30

#define SET_GAIN						0x61
#define SET_GAIN_size					6
#define SET_GAIN_wait1					20
#define SET_GAIN_wait2					350
#define SET_GAIN_wait3					30

#define SET_PED_TH						0x83
#define SET_PED_TH_size					16
#define SET_PED_TH_wait1				20
#define SET_PED_TH_wait2				500
#define SET_PED_TH_wait3				30

#define wait500m				delay_ms(500)
#define wait20m					delay_ms(20)
#define wait30m					delay_ms(30)
#define wait50m					delay_ms(50)

void ami602_reset(void);			// `bvZbg
void ami602_active(void);			// Active modeɑJ
void ami602_suspend(void);			// Suspend modeɑJ
void ami602_down(void);				// Power down modeɑJ

void bc_ami602_READ_CMD(
	unsigned char,
	unsigned int,
	unsigned char *,
	unsigned int,
	unsigned int,
	unsigned int );


unsigned char bc_ami602_WRITE_CMD(
	unsigned int,
	unsigned char *,
	unsigned int,
	unsigned int,
	unsigned int );


#endif // __BC_AMI602_H__